Index: /branches/dev_001_GM/NEMO/OFF_SRC/IOM/iom_rstdimg.F90
===================================================================
--- /branches/dev_001_GM/NEMO/OFF_SRC/IOM/iom_rstdimg.F90	(revision 950)
+++ /branches/dev_001_GM/NEMO/OFF_SRC/IOM/iom_rstdimg.F90	(revision 951)
@@ -31,7 +31,10 @@
       MODULE PROCEDURE iom_rstdimg_rp0d, iom_rstdimg_rp123d
    END INTERFACE
+
+   INTEGER, PARAMETER ::   jpvnl          = 32   ! variable name length
+      
    !!----------------------------------------------------------------------
    !!  OPA 9.0 , LOCEAN-IPSL (2006)
-   !! $Header$
+   !! $Header: /home/opalod/NEMOCVSROOT/NEMO/OPA_SRC/IOM/iom_rstdimg.F90,v 1.9 2007/06/29 14:10:50 opalod Exp $
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
@@ -45,9 +48,9 @@
       !! ** Purpose :  open an input file read only (return 0 if not found)
       !!---------------------------------------------------------------------
-      CHARACTER(len=*)       , INTENT(inout) ::   cdname   ! File name
-      INTEGER                , INTENT(  out) ::   kiomid   ! iom identifier of the opened file
-      LOGICAL                , INTENT(in   ) ::   ldwrt    ! read or write the file?
-      LOGICAL                , INTENT(in   ) ::   ldok     ! check the existence 
-      INTEGER, DIMENSION(2,5), INTENT(in   ) ::   kdompar  ! domain parameters: 
+      CHARACTER(len=*)       , INTENT(inout)           ::   cdname   ! File name
+      INTEGER                , INTENT(  out)           ::   kiomid   ! iom identifier of the opened file
+      LOGICAL                , INTENT(in   )           ::   ldwrt    ! read or write the file?
+      LOGICAL                , INTENT(in   )           ::   ldok     ! check the existence 
+      INTEGER, DIMENSION(2,5), INTENT(in   ), OPTIONAL ::   kdompar  ! domain parameters: 
 
       CHARACTER(LEN=100)                      ::   clinfo                     ! info character
@@ -59,4 +62,5 @@
       INTEGER                                 ::   irecl8                     ! record length
       INTEGER                                 ::   ios                        ! IO status
+      INTEGER                                 ::   irhd                       ! record of the header infos
       INTEGER                                 ::   ivnum                      ! number of variables
       INTEGER                                 ::   ishft                      ! counter shift
@@ -64,9 +68,10 @@
       INTEGER                                 ::   in0d, in1d, in2d, in3d     ! number of 0/1/2/3D variables
       INTEGER                                 ::   ipni, ipnj, ipnij, iarea   ! domain decomposition 
-      CHARACTER(LEN=8), DIMENSION(jpmax_vars) ::   clna0d, clna1d, clna2d, clna3d     ! name of 0/1/2/3D variables
+      INTEGER                                 ::   iiglo, ijglo               ! domain global size 
+      INTEGER                                 ::   jl                         ! loop variable
+      CHARACTER(LEN=jpvnl), DIMENSION(jpmax_vars) ::   clna0d, clna1d, clna2d, clna3d     ! name of 0/1/2/3D variables
       REAL(wp),         DIMENSION(jpmax_vars) ::   zval0d, zval1d, zval2d, zval3d     ! value of 0d variables or record
       !                                                                               ! position for 1/2/3D variables
       !---------------------------------------------------------------------
-
       clinfo = '                    iom_rstdimg_open ~~~  '
       istop = nstop      ! store the actual value of nstop
@@ -99,7 +104,7 @@
          iln = INDEX( cdname, '.dimg' )
          IF( ldwrt ) THEN  ! the file should be open in readwrite mode so we create it...
-            irecl8= kdompar(1,1) * kdompar(2,1) * wp
+            irecl8= MAX( kdompar(1,1) * kdompar(2,1) * wp, ( 8*jpnij + 15 ) * 4 )
             IF( jpnij > 1 ) THEN
-               WRITE(cltmp,'(a,a,i4.4,a)') cdname(1:iln-1), '_', narea-1, '.dimg'
+               WRITE(cltmp,'(a,a,i4.4,a)') cdname(1:iln-1), '_', narea, '.dimg'
                cdname = TRIM(cltmp)
             ENDIF
@@ -108,5 +113,5 @@
                &       , RECL = irecl8, STATUS = 'new', ACTION = 'readwrite', IOSTAT = ios, ERR = 987 )
          ELSE              ! the file should be open for read mode so it must exist...
-            CALL ctl_stop( TRIM(clinfo), 'File '//cdname(1:iln-1)//'* not found' )
+            CALL ctl_stop( TRIM(clinfo), ' should be impossible case...' )
          ENDIF
       ENDIF
@@ -114,12 +119,17 @@
       ! =============
       IF( ldok ) THEN      ! old file
-         READ( idrst, REC = 1, IOSTAT = ios, ERR = 987 ) irecl8, inx, iny, inz, in0d, in1d, in2d, in3d
-         READ( idrst, REC = 1, IOSTAT = ios, ERR = 987 ) irecl8, inx, iny, inz, in0d, in1d, in2d, in3d,   &
+         READ( idrst, REC = 1   , IOSTAT = ios, ERR = 987 )              &
+              &   irecl8, inx, iny, inz, in0d, in1d, in2d, in3d, irhd,   &
+              &   ipni, ipnj, ipnij, iarea, iiglo, ijglo
+         READ( idrst, REC = irhd, IOSTAT = ios, ERR = 987 )                       &
             &   clna0d(1:in0d), zval0d(1:in0d), clna1d(1:in1d), zval1d(1:in1d),   &
-            &   clna2d(1:in2d), zval2d(1:in2d), clna3d(1:in3d), zval3d(1:in3d),   &
-            &   ipni, ipnj, ipnij, iarea 
+            &   clna2d(1:in2d), zval2d(1:in2d), clna3d(1:in3d), zval3d(1:in3d)
          clinfo = TRIM(clinfo)//' file '//TRIM(cdname)
-         IF( inx   /= kdompar(1,1) )   CALL ctl_stop( TRIM(clinfo), 'Mismatch in domain size in i direction' )
-         IF( iny   /= kdompar(2,1) )   CALL ctl_stop( TRIM(clinfo), 'Mismatch in domain size in j direction' )
+         IF( iiglo /= jpiglo       )   CALL ctl_stop( TRIM(clinfo), 'Mismatch in global domain size in i direction' )
+         IF( ijglo /= jpjglo       )   CALL ctl_stop( TRIM(clinfo), 'Mismatch in global domain size in j direction' )
+         IF( ldwrt ) THEN
+            IF( inx   /= kdompar(1,1) )   CALL ctl_stop( TRIM(clinfo), 'Mismatch in local domain size in i direction' )
+            IF( iny   /= kdompar(2,1) )   CALL ctl_stop( TRIM(clinfo), 'Mismatch in local domain size in j direction' )
+         ENDIF
          IF( inz   /= jpk          )   CALL ctl_stop( TRIM(clinfo), 'Mismatch in domain size in k direction' )
          IF( ipni  /= jpni         )   CALL ctl_stop( TRIM(clinfo), 'Processor splitting changed along I' )
@@ -131,5 +141,9 @@
       ! =============
       IF( istop == nstop ) THEN   ! no error within this routine
-         kiomid = MINLOC(iom_file(:)%nfid, dim = 1)
+!does not work with some compilers         kiomid = MINLOC(iom_file(:)%nfid, dim = 1)
+         kiomid = 0
+         DO jl = jpmax_files, 1, -1
+            IF( iom_file(jl)%nfid == 0 )   kiomid = jl
+         ENDDO
          iom_file(kiomid)%name    = TRIM(cdname)
          iom_file(kiomid)%nfid    = idrst
@@ -209,10 +223,11 @@
       INTEGER                                 ::   irecl8                     ! record length
       INTEGER                                 ::   ios                        ! IO status
+      INTEGER                                 ::   irhd                       ! record of the header infos
       INTEGER                                 ::   ivnum                      ! number of variables
       INTEGER                                 ::   idrst                      ! file logical unit
       INTEGER                                 ::   inx, iny, inz              ! x,y,z dimension of the variable
       INTEGER                                 ::   in0d, in1d, in2d, in3d     ! number of 0/1/2/3D variables
-      CHARACTER(LEN=8), DIMENSION(jpmax_vars) ::   clna0d, clna1d, clna2d, clna3d     ! name of 0/1/2/3D variables
-      REAL(wp),         DIMENSION(jpmax_vars) ::   zval0d, zval1d, zval2d, zval3d     ! value of 0d variables or record
+      CHARACTER(LEN=jpvnl), DIMENSION(jpmax_vars) ::   clna0d, clna1d, clna2d, clna3d    ! name of 0/1/2/3D variables
+      REAL(wp),          DIMENSION(jpmax_vars) ::   zval0d, zval1d, zval2d, zval3d    ! value of 0d variables or record
       !                                                                               ! position for 1/2/3D variables
       !---------------------------------------------------------------------
@@ -226,4 +241,5 @@
       IF( ios == 0 ) THEN
          READ( idrst, REC = 1, IOSTAT = ios, ERR = 987 ) irecl8, inx, iny, inz   ! get back domain size
+         irhd = iom_file(kiomid)%irec
          ivnum = iom_file(kiomid)%nvars
          in0d = 0   ;   in1d = 0   ;   in2d = 0   ;   in3d = 0
@@ -249,5 +265,5 @@
             END SELECT
          END DO
-         ! force to have at least 1 valriable in each list (not necessary (?), but safer)
+         ! force to have at least 1 variable in each list (not necessary (?), but safer...)
          IF( in0d == 0 ) THEN   ;   in0d = 1   ;   clna0d(1) = 'no0d'   ;   zval0d(1) = -1.   ;   ENDIF
          IF( in1d == 0 ) THEN   ;   in1d = 1   ;   clna1d(1) = 'no1d'   ;   zval1d(1) = -1.   ;   ENDIF
@@ -255,8 +271,16 @@
          IF( in3d == 0 ) THEN   ;   in3d = 1   ;   clna3d(1) = 'no3d'   ;   zval3d(1) = -1.   ;   ENDIF
          ! update the file header before closing it
-         WRITE( idrst, REC = 1, IOSTAT = ios, ERR = 987 ) irecl8, inx, iny, inz, in0d, in1d, in2d, in3d,   &
-            &   clna0d(1:in0d), zval0d(1:in0d), clna1d(1:in1d), zval1d(1:in1d),   &
-            &   clna2d(1:in2d), zval2d(1:in2d), clna3d(1:in3d), zval3d(1:in3d),   &
-            &   jpni, jpnj, jpnij, narea, jpiglo, jpjglo, nlcit, nlcjt, nldit, nldjt, nleit, nlejt, nimppt, njmppt
+         WRITE( idrst, REC = 1, IOSTAT = ios, ERR = 987 )              &
+            &   irecl8, inx, iny, inz, in0d, in1d, in2d, in3d, irhd,   &
+            &   jpni, jpnj, jpnij, narea, jpiglo, jpjglo,              &
+            &   nlcit, nlcjt, nldit, nldjt, nleit, nlejt, nimppt, njmppt
+         IF( (ivnum * (jpvnl + wp)) > irecl8 ) THEN 
+            CALL ctl_stop( TRIM(clinfo),   &
+                 &   'Last record size is too big... You could reduce the value of jpvnl' )
+         ELSE 
+            WRITE( idrst, REC = irhd, IOSTAT = ios, ERR = 987 )                        &
+                 &   clna0d(1:in0d), zval0d(1:in0d), clna1d(1:in1d), zval1d(1:in1d),   &
+                 &   clna2d(1:in2d), zval2d(1:in2d), clna3d(1:in3d), zval3d(1:in3d)
+         ENDIF
       ELSE
          ios = 0   ! we cannot write in the file
@@ -290,5 +314,5 @@
 
 
-   SUBROUTINE iom_rstdimg_rp0d( kiomid, cdvar, pv_r0d )
+   SUBROUTINE iom_rstdimg_rp0d( kiomid, cdvar, kvid, pv_r0d )
       !!--------------------------------------------------------------------
       !!                   ***  SUBROUTINE  iom_rstdimg_rstput  ***
@@ -298,4 +322,5 @@
       INTEGER                   , INTENT(in) ::   kiomid   ! Identifier of the file 
       CHARACTER(len=*)          , INTENT(in) ::   cdvar    ! time axis name
+      INTEGER                   , INTENT(in) ::   kvid     ! variable id
       REAL(wp)                  , INTENT(in) ::   pv_r0d   ! written 0d field
       !
@@ -305,5 +330,9 @@
       !  
       clinfo = '                    iom_rstdimg_rp0d ~~~  '
-      idvar = iom_file(kiomid)%nvars + 1
+      IF( kvid <= 0 ) THEN   !   new variable
+         idvar = iom_file(kiomid)%nvars + 1
+      ELSE                   !   the variable already exists in the file
+         idvar = kvid
+      ENDIF
       IF( idvar <= jpmax_vars ) THEN
          iom_file(kiomid)%nvars = idvar
@@ -320,6 +349,6 @@
 
 
-   SUBROUTINE iom_rstdimg_g123d( kiomid, kdom  , kvid  , kstart, kcount,    &
-         &                          pv_r1d, pv_r2d, pv_r3d )
+   SUBROUTINE iom_rstdimg_g123d( kiomid, kdom  , kvid, kx1, kx2, ky1, ky2,   &
+         &                       pv_r1d, pv_r2d, pv_r3d )
       !!-----------------------------------------------------------------------
       !!                  ***  ROUTINE  iom_rstdimg_g123d  ***
@@ -332,6 +361,5 @@
       INTEGER                    , INTENT(in   )           ::   kdom       ! Type of domain to be read
       INTEGER                    , INTENT(in   )           ::   kvid       ! variable id
-      INTEGER , DIMENSION(:)     , INTENT(in   )           ::   kstart     ! start position of the reading in each axis 
-      INTEGER , DIMENSION(:)     , INTENT(in   )           ::   kcount     ! number of points to be read in each axis
+      INTEGER ,                    INTENT(inout)           ::   kx1, kx2, ky1, ky2   ! subdomain indexes
       REAL(wp), DIMENSION(:)     , INTENT(  out), OPTIONAL ::   pv_r1d     ! read field (1D case)
       REAL(wp), DIMENSION(:,:)   , INTENT(  out), OPTIONAL ::   pv_r2d     ! read field (2D case)
@@ -342,60 +370,31 @@
       INTEGER            ::   jk                   ! loop counter
       INTEGER            ::   idrst                ! logical unit of the restart file
-      INTEGER            ::   istop                ! temporary storage of nstop
-      INTEGER            ::   ix1, ix2, iy1, iy2   ! subdomain indexes
       !---------------------------------------------------------------------
       clinfo = '                    iom_rstdimg_g123d ~~~  '
       !
-      istop = nstop                   ! store the actual value of nstop
-      idrst = iom_file(kiomid)%nfid   ! get back the logical unit of the restart file
-      IF( kdom == jpdom_data .OR. kdom == jpdom_global )   &
-            &   CALL ctl_stop( TRIM(clinfo), TRIM(iom_file(kiomid)%cn_var(kvid))//': case not coded for rstdimg files' )
-      !
-      IF( istop == nstop .AND. kvid > 0 ) THEN
-         IF( .NOT. PRESENT(pv_r1d) ) THEN
-            SELECT CASE (kdom)   ! find the right index of the array to be read
-            CASE (jpdom_local_full)      ;   ix1 = nldi   ;   ix2 = nlei   ;   iy1 = nldj   ;   iy2 = nlej
-            CASE (jpdom_local_noextra)   ;   ix1 = 1      ;   ix2 = nlci   ;   iy1 = 1      ;   iy2 = nlcj
-            CASE (jpdom_local_noovlap)   ;   ix1 = nldi   ;   ix2 = nlei   ;   iy1 = nldj   ;   iy2 = nlej
-            CASE DEFAULT                 ;   CALL ctl_stop( clinfo, 'we should not be there...' )
-            END SELECT
-         ENDIF
+      IF( kdom == jpdom_data .OR. kdom == jpdom_global ) THEN
+         CALL ctl_stop( TRIM(clinfo), TRIM(iom_file(kiomid)%cn_var(kvid))//': case not coded for rstdimg files' )
+      ELSE
+      !
+         idrst = iom_file(kiomid)%nfid   ! get back the logical unit of the restart file
+         ! modify the subdomain indexes because we cannot directly extract the appropriate subdomaine
+         IF(     kdom == jpdom_local_full    ) THEN   ;   kx1 = 1   ;   kx2 = jpi    ;   ky1 = 1
+         ELSEIF( kdom == jpdom_local_noextra ) THEN   ;   kx1 = 1   ;   kx2 = nlci   ;   ky1 = 1
+         ENDIF
+         !
          IF(     PRESENT(pv_r1d) ) THEN   ! read 1D variables
-            READ( idrst, REC = iom_file(kiomid)%nvid(kvid), IOSTAT = ios, ERR = 987 )   pv_r1d(:)
+            READ(    idrst, REC = iom_file(kiomid)%nvid(kvid)         , IOSTAT = ios, ERR = 987 )   pv_r1d(:)
          ELSEIF( PRESENT(pv_r2d) ) THEN   ! read 2D variables
-            READ( idrst, REC = iom_file(kiomid)%nvid(kvid), IOSTAT = ios, ERR = 987 )   pv_r2d(ix1:ix2, iy1:iy2 )
-            SELECT CASE (kdom)
-            CASE (jpdom_local_noextra)   !--- Fill extra hallows (mpp)       
-               pv_r2d(nlci+1:jpi,      :   ) = 1.    
-               pv_r2d(      :   ,nlcj+1:jpj) = 1.            
-            CASE (jpdom_local_noovlap)   !--- Fill the overlap areas and extra hallows (mpp)
-               CALL lbc_lnk (pv_r2d,'Z',-999.,'no0')
-            CASE DEFAULT
-            END SELECT
+            READ(    idrst, REC = iom_file(kiomid)%nvid(kvid)         , IOSTAT = ios, ERR = 987 )   pv_r2d(kx1:kx2, ky1:ky2    )
          ELSEIF( PRESENT(pv_r3d) ) THEN   ! read 3D variables
             DO jk = 1, iom_file(kiomid)%dimsz(3,kvid)   ! do loop on each level
-               READ( idrst, REC = iom_file(kiomid)%nvid(kvid) + jk - 1, IOSTAT = ios, ERR = 987 )   &
-                     &      pv_r3d( ix1:ix2, iy1:iy2, jk )
-            END DO
-            SELECT CASE (kdom)
-            CASE (jpdom_local_noextra)   !--- Fill extra hallows (mpp)       
-               pv_r3d(nlci+1:jpi,      :   ,:) = 1.    
-               pv_r3d(      :   ,nlcj+1:jpj,:) = 1.            
-            CASE (jpdom_local_noovlap)   !--- Fill the overlap areas and extra hallows (mpp)
-               ! this if could be simplified with the new lbc_lnk that works with any size of the 3rd dimension
-               IF( kcount(3) == jpk ) THEN
-                  CALL lbc_lnk( pv_r3d,'Z',-999.,'no0' )
-               ELSE
-                  pv_r3d(nlei+1:jpi,      :   ,:) = 1.            
-                  pv_r3d(      :   ,nlej+1:jpj,:) = 1.            
-               ENDIF
-            CASE DEFAULT
-            END SELECT
-         ENDIF
-      ENDIF
-987   CONTINUE
-      IF( ios /= 0 ) THEN
-         WRITE(ctmp1,*) '           iostat = ', ios
-         CALL ctl_stop( TRIM(clinfo), '   IO error with file '//TRIM(iom_file(kiomid)%name), ctmp1 )
+               READ( idrst, REC = iom_file(kiomid)%nvid(kvid) + jk - 1, IOSTAT = ios, ERR = 987 )   pv_r3d(kx1:kx2, ky1:ky2, jk)
+            END DO
+         ENDIF
+987      CONTINUE
+         IF( ios /= 0 ) THEN
+            WRITE(ctmp1,*) '           iostat = ', ios
+            CALL ctl_stop( TRIM(clinfo), '   IO error with file '//TRIM(iom_file(kiomid)%name), ctmp1 )
+         ENDIF
       ENDIF
       !
@@ -403,5 +402,5 @@
 
 
-   SUBROUTINE iom_rstdimg_rp123d( kiomid, cdvar, pv_r1d, pv_r2d, pv_r3d )
+   SUBROUTINE iom_rstdimg_rp123d( kiomid, cdvar, kvid, pv_r1d, pv_r2d, pv_r3d )
       !!--------------------------------------------------------------------
       !!                   ***  SUBROUTINE  iom_rstdimg_rstput  ***
@@ -411,4 +410,5 @@
       INTEGER                         , INTENT(in)           ::   kiomid   ! Identifier of the file 
       CHARACTER(len=*)                , INTENT(in)           ::   cdvar    ! time axis name
+      INTEGER                         , INTENT(in)           ::   kvid     ! variable id
       REAL(wp), DIMENSION(        jpk), INTENT(in), OPTIONAL ::   pv_r1d   ! written 1d field
       REAL(wp), DIMENSION(jpi,jpj    ), INTENT(in), OPTIONAL ::   pv_r2d   ! written 2d field
@@ -431,5 +431,9 @@
       irec = iom_file(kiomid)%irec    ! get back the record number of the variable
       idrst = iom_file(kiomid)%nfid   ! get back the logical unit of the restart file
-      idvar = iom_file(kiomid)%nvars + 1
+      IF( kvid <= 0 ) THEN   !   new variable
+         idvar = iom_file(kiomid)%nvars + 1
+      ELSE                   !   the variable already exists in the file
+         idvar = kvid
+      ENDIF
       IF( idvar > jpmax_vars )   CALL ctl_stop( TRIM(clinfo), 'increase the value of jpmax_vars' )
       IF( .NOT. PRESENT(pv_r1d) ) THEN
